package cn.com.infosec.mobile.android.framework.utils;

import cn.com.infosec.asn1.DERConstructedSequence;
import cn.com.infosec.asn1.DERConstructedSet;
import cn.com.infosec.asn1.DERInputStream;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.DEROutputStream;
import cn.com.infosec.asn1.DERTaggedObject;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.security.cert.Certificate;
import java.security.cert.CertificateEncodingException;

public class PKCS7CertChianGenerator {
   private final String ID_PKCS7_DATA = "1.2.840.113549.1.7.1";
   private final String ID_PKCS7_SIGNED_DATA = "1.2.840.113549.1.7.2";

   public byte[] genP7CertChain(Certificate[] certChain) {
      CertificateEncodingException var10000;
      boolean var10001;
      IOException var31;
      DERConstructedSet var32;
      try {
         var32 = new DERConstructedSet;
      } catch (IOException var25) {
         var31 = var25;
         var10001 = false;
         throw var31;
      } catch (CertificateEncodingException var26) {
         var10000 = var26;
         var10001 = false;
         throw var10000;
      }

      DERConstructedSet var27 = var32;

      DERConstructedSequence var33;
      try {
         var32.<init>();
         var33 = new DERConstructedSequence;
      } catch (IOException var23) {
         var31 = var23;
         var10001 = false;
         throw var31;
      } catch (CertificateEncodingException var24) {
         var10000 = var24;
         var10001 = false;
         throw var10000;
      }

      DERConstructedSequence var2;
      DERConstructedSequence var34 = var2 = var33;

      try {
         var34.<init>();
         var33.addObject(new DERObjectIdentifier("1.2.840.113549.1.7.1"));
         var32 = new DERConstructedSet;
      } catch (IOException var21) {
         var31 = var21;
         var10001 = false;
         throw var31;
      } catch (CertificateEncodingException var22) {
         var10000 = var22;
         var10001 = false;
         throw var10000;
      }

      DERConstructedSet var3 = var32;

      try {
         var32.<init>();
      } catch (IOException var19) {
         var31 = var19;
         var10001 = false;
         throw var31;
      } catch (CertificateEncodingException var20) {
         var10000 = var20;
         var10001 = false;
         throw var10000;
      }

      int var4 = 0;

      while(true) {
         int var36;
         int var37;
         try {
            var36 = var4;
            var37 = certChain.length;
         } catch (IOException var15) {
            var31 = var15;
            var10001 = false;
            throw var31;
         } catch (CertificateEncodingException var16) {
            var10000 = var16;
            var10001 = false;
            break;
         }

         if (var36 >= var37) {
            try {
               var33 = new DERConstructedSequence;
            } catch (IOException var13) {
               var31 = var13;
               var10001 = false;
               throw var31;
            } catch (CertificateEncodingException var14) {
               var10000 = var14;
               var10001 = false;
               break;
            }

            var34 = var33;
            DERConstructedSequence certChain1;
            DERConstructedSequence var10002 = certChain1 = var33;

            try {
               certChain1.<init>();
               certChain1.addObject(new DERInteger(1));
               certChain1.addObject(var27);
               var10002.addObject(var2);
               var34.addObject(new DERTaggedObject(false, 0, var3));
               var33.addObject(new DERConstructedSet());
               var33 = new DERConstructedSequence;
            } catch (IOException var11) {
               var31 = var11;
               var10001 = false;
               throw var31;
            } catch (CertificateEncodingException var12) {
               var10000 = var12;
               var10001 = false;
               break;
            }

            var34 = var33;
            DERConstructedSequence var28;
            var10002 = var28 = var33;

            ByteArrayOutputStream var38;
            try {
               var10002.<init>();
               var34.addObject(new DERObjectIdentifier("1.2.840.113549.1.7.2"));
               var33.addObject(new DERTaggedObject(0, certChain1));
               var38 = new ByteArrayOutputStream;
            } catch (IOException var9) {
               var31 = var9;
               var10001 = false;
               throw var31;
            } catch (CertificateEncodingException var10) {
               var10000 = var10;
               var10001 = false;
               break;
            }

            ByteArrayOutputStream certChain2;
            ByteArrayOutputStream var39 = certChain2 = var38;

            DEROutputStream var40;
            try {
               var39.<init>();
               var40 = new DEROutputStream;
            } catch (IOException var7) {
               var31 = var7;
               var10001 = false;
               throw var31;
            } catch (CertificateEncodingException var8) {
               var10000 = var8;
               var10001 = false;
               break;
            }

            DEROutputStream var35 = var40;
            DEROutputStream var10003 = var40;

            try {
               var10003.<init>(certChain2);
               var35.writeObject(var28);
               var40.close();
               return var38.toByteArray();
            } catch (IOException var5) {
               var31 = var5;
               var10001 = false;
               throw var31;
            } catch (CertificateEncodingException var6) {
               var10000 = var6;
               var10001 = false;
               break;
            }
         }

         try {
            var3.addObject((new DERInputStream(new ByteArrayInputStream(certChain[var4].getEncoded()))).readObject());
         } catch (IOException var17) {
            var31 = var17;
            var10001 = false;
            throw var31;
         } catch (CertificateEncodingException var18) {
            var10000 = var18;
            var10001 = false;
            break;
         }

         ++var4;
      }

      throw var10000;
   }
}
